
/* ##############################################################
	설  명 : [Modal]조직 등록 팝업
	작성일 : 2023. 01. 19.
	작성자 : NTsoft
	수정일 	        수정자 	 수정내용
	-------         -------- ---------------------------
	2023. 01. 19.	NTsoft 	 최초 생성
*/
let groupInsertModal = {
	callback : null,
	reqParam : null,
	dataList : null,
	/* 모달 초기화 작업 */
	init : function () {
		$('#groupInsertModal').remove();
		$('body').append( this.HtmlTemplate);
		//그리드 이벤트
		this.setEvent();
	},
	/* 그리드 이벤트 설정 */
	setEvent:function() {
		$('#groupInsertModal .btnCancle').on("click", function(){
			groupInsertModal.close();
		});
		
		$('#groupInsertModal .btnSave').on("click", function(){
			groupInsertModal.save("I");
		});

        $('#groupInsertModal #modalorderNumber').on('input', function() {
            // 입력된 키가 숫자가 아닌 경우 입력을 막음
            this.value = this.value.replace(/\D/g, '');
        });
	},
	/* 데이터 선택 */
	setSelect:function(selectNumber) {
		let checkedData = dataList[selectNumber];
		if(dataList==null||checkedData==undefined){
			return ;
		}
		
		if( groupInsertModal.callback )  {
			groupInsertModal.callback(checkedData);
		}
		groupInsertModal.close();
	},
	//저장
	save:function(state) {
		let groupName     = $("#groupInsertModal #modalGroupName").val();
		let orderNumber     = $("#groupInsertModal #modalorderNumber").val();
		let etc           = $("#groupInsertModal #modalEtc").val();
		
		if(true != fn_emptyCheck(groupName)){
			modalEvent.warning("등록", "조직명 정보가 없습니다.");	
			return;
		}
		else{
			if(true != fn_lengthCheck(groupName, 35)) {
				modalEvent.warning("등록", "조직명 정보는 35자를 넘을 수 없습니다.");	
				return;
			}
		}
		if(true != fn_emptyCheck(orderNumber)){
			modalEvent.warning("등록", "정렬 순서가 없습니다.");
			return;
		}
		
		modalEvent.info("등록", "조직 정보를 등록하시겠습니까?", function(){
			let formData = new FormData();
			formData.append("menuClass", menuClass);
			formData.append("orderNumber", orderNumber);
			formData.append("groupName", groupName);
			formData.append("etc", etc);
	
			$.ajax({
				url: encodeURI('/webgroup/insertGroup.do'),
				data: formData,
				dataType: "json",
				processData: false,
				contentType: false,
				type: 'POST',
				async: true,
				success: function(data){
					if('0'==data.msgCode){
						modalEvent.success("등록 성공", data.msgDesc, function(){
							if( groupInsertModal.callback )  {
								groupInsertModal.callback();
							}
							groupInsertModal.close();
						});
					}
					else{
						modalEvent.danger("등록 오류", data.msgDesc);
					}
				},
				error : function(xhr, status, error) {
					modalEvent.danger("등록 오류", "등록 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
				},
				beforeSend:function(){
					
				},
				complete:function(){
					
				}
			});
		});
	},
	/*
	 * 팝업
	 * callback : 콜백함수, reqParam: 팝업파라미터
	 */
	popup:function(callback, reqParam) {
		// 초기화 후 열기
		groupInsertModal.init();
		
		//콜백함수 지정.
		groupInsertModal.callback = callback;
		groupInsertModal.reqParam = reqParam;
		groupInsertModal.dataList = null;
		
		setTimeout(function(){
			$('#groupInsertModal').modal('show')
		}, 200);
	},
	/*
	 * 팝업 닫기
	 */
	close:function() {
		$('#groupInsertModal').modal('hide');

		setTimeout(function(){
			$('#groupInsertModal').remove();
		},500);
	},
	HtmlTemplate : `
	<div id="groupInsertModal" class="modal group_item_modal fade" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="">
		<div class="modal-dialog">
			<div class="modal-content">
				<div class="modal-header">
					<p class="title">조직 추가</p>
				</div>
	
				<div class="modal-body">
					<div class="form_box">
						<div class="input_box">
							<label>조직 명</label>
							<input type="text" id="modalGroupName" placeholder="조직 명" maxlength="35">
						</div>
						<div class="input_box">
							<label>정렬 순서</label>
							<input type="number" id="modalorderNumber" placeholder="0" maxlength="35">
						</div>
						<div class="textarea_box">
							<label>메모</label>
							<textarea id="modalEtc" placeholder="메모를 입력해주세요."></textarea>
						</div>
					</div>
				</div>

				<div class="modal-footer">
					<div class="btn_box">
						<button type="button" class="cancel_btn btnCancle">취소</button>
						<button type="button" class="registration_bth btnSave">등록</button>
					</div>
				</div>
			</div>
		</div>
	</div>
    `
};

